## Installation
This repository is tested on Python 3.8.12.  
All dependencies are listed in `requirements.txt`

## Dataset Preprocessing
We provide a small sample of the CNN/DM validation set in `data` folder. Each line contains the source document, the gold summary and ROUGE-1 overlap scores of each source sentence with respect to the summary.

All samples of CNN/DM can be preprocessed like this.

## RQ1: SP-Search

All code is present in the `sp_search` directory and the search can be run from `main.py`.
 
## RQ2: SP Generation Models

All code is present in the `sp_model` directory.

The SP models can be trained using `scripts/train_sp_gen.sh`

The trained SP models can be used to generate programs using `sp_model/eval_sp.py`

Finally, the generated programs can be executed to generate summaries using `sp_model/execute_sp.py`